namespace tlang
{
    internal class DivideNode : Node
    {
        public Node Left {get;set;}
        public Node Right {get;set;}

        public DivideNode(Node left, Node right)
        {
            this.Left = left;
            this.Right = right;
        }

        public override TObject Execute(IScopeEnvironment nodeEnv)
        {
             var l = Left.Execute(nodeEnv);
            var r = Right.Execute(nodeEnv);
            var lnum = l as TNumber;
            var rnum = r as TNumber;
             var dleft = l as TDictionary;

            if(dleft != null)
            {
                if(dleft.MemberExists("divide"))
                {
                    var mbm = dleft["divide"] as ICallable;
                    if(mbm != null)
                    {
                        return mbm.Call(r);
                    }
                }
            }

            if(lnum != null && rnum != null)
            return new TNumber(lnum.Value / rnum.Value);

            return new TNull();
        }
    }
}